//< 1. Property >=============================================================================================//<   1>
                                                                                                              //<   2>
#property     copyright                 "Copyright (C) 2009, MetaQuotes Software Corp."                       //<   3>
#property     link                      "http://www.metaquotes.net"                                           //<   4>
                                                                                                              //<   5>
#define       A_System_Series           "AIS"                                                                 //<   6>
#define       A_System_Modification     "10331"                                                               //<   7>
#define       A_System_ReleaseDate      "11.03.2009"                                                          //<   8>
#define       A_System_Program          "Advanced Indicator Superlight"                                       //<   9>
#define       A_System_Programmer       "Airat Safin                           http://www.mql4.com/users/Ais" //<  10>
                                                                                                              //<  11>
//</1. Property >=============================================================================================//<  12>
                                                                                                              //<  13>
//< 2. Program     >==========================================================================================//<  14>
                                                                                                              //<  15>
//< 2.1. Global Data >----------------------------------------------------------------------------------------//<  16>
                                                                                                              //<  17>
string        A_System_Name           = "A System"                                                          ; //<  18>
                                                                                                              //<  19>
string        avs_SystemStamp                                                                               ; //<  20>
                                                                                                              //<  21>
extern int    aei_ID                  = 8                                                                   ; //<  22>
                                                                                                              //<  23>
int           aci_Timeframe      [] = { 0 , 1 , 5 , 15 , 30 , 60 , 240 , 1440 , 10080 , 43200             } ; //<  24>
                                                                                                              //<  25>
int           aci_Color          [] = { Black                                                             ,   //<  26>
                                        Red                                                               ,   //<  27>
                                        Orange                                                            ,   //<  28>
                                        Yellow                                                            ,   //<  29>
                                        Green                                                             ,   //<  30>
                                        Blue                                                              ,   //<  31>
                                        Indigo                                                            ,   //<  32>
                                        Violet                                                            ,   //<  33>
                                        Gray                                                              ,   //<  34>
                                        White                                                             } ; //<  35>
                                                                                                              //<  36>
#property     indicator_chart_window                                                                          //<  37>
                                                                                                              //<  38>
double        arv_Chart          [] = { EMPTY                                                               , //<  39>
                                        EMPTY                                                               , //<  40>
                                        EMPTY                                                               , //<  41>
                                        EMPTY                                                               , //<  42>
                                        EMPTY                                                               , //<  43>
                                        EMPTY                                                               , //<  44>
                                        EMPTY                                                               , //<  45>
                                        EMPTY                                                               , //<  46>
                                        EMPTY                                                               , //<  47>
                                        EMPTY                                                               , //<  48>
                                        EMPTY                                                               , //<  49>
                                        EMPTY                                                             } ; //<  50>
                                                                                                              //<  51>
#define       ari_TimeZero              0                                                                     //<  52>
#define       ari_TimeRight             1                                                                     //<  53>
#define       ari_TimeLeft              2                                                                     //<  54>
#define       ari_BarRight              3                                                                     //<  55>
#define       ari_BarLeft               4                                                                     //<  56>
#define       ari_BarsTotal             5                                                                     //<  57>
#define       ari_BarsShift             6                                                                     //<  58>
#define       ari_Resolution_H          7                                                                     //<  59>
#define       ari_PriceMax              8                                                                     //<  60>
#define       ari_PriceMin              9                                                                     //<  61>
#define       ari_PriceRange            10                                                                    //<  62>
#define       ari_Resolution_V          11                                                                    //<  63>
                                                                                                              //<  64>
string        avs_Prefix                                                                                    ; //<  65>
                                                                                                              //<  66>
string        avs_PrefixSynthBars                                                                           ; //<  67>
string        avs_PrefixSynthMeanA                                                                          ; //<  68>
string        avs_PrefixSynthMeanB                                                                          ; //<  69>
string        avs_PrefixSynthSlopeA                                                                         ; //<  70>
string        avs_PrefixSynthSlopeB                                                                         ; //<  71>
                                                                                                              //<  72>
string        avs_SetupBegin                                                                                ; //<  73>
string        avs_SetupSynthFrames                                                                          ; //<  74>
string        avs_SetupSynthSize                                                                            ; //<  75>
string        avs_SetupColorBars                                                                            ; //<  76>
string        avs_SetupColorMeans                                                                           ; //<  77>
string        avs_SetupColorSlopes                                                                          ; //<  78>
string        avs_SetupEnd                                                                                  ; //<  79>
                                                                                                              //<  80>
int           avi_SetupBegin          = 1000000000                                                          ; //<  81>
int           avi_SetupSynthFrames    = 1                                                                   ; //<  82>
int           avi_SetupSynthSize                                                                            ; //<  83>
int           avi_SetupColorBars                                                                            ; //<  84>
int           avi_SetupColorMeans                                                                           ; //<  85>
int           avi_SetupColorSlopes                                                                          ; //<  86>
int           avi_SetupEnd            = 1000000000                                                          ; //<  87>
                                                                                                              //<  88>
int           avi_FlagSynthFramesShow                                                                       ; //<  89>
int           avi_FlagSynthFramesCreate                                                                     ; //<  90>
                                                                                                              //<  91>
int           avi_IndexSynthBegin                                                                           ; //<  92>
int           avi_IndexSynthEnd                                                                             ; //<  93>
int           avi_Synths                                                                                    ; //<  94>
                                                                                                              //<  95>
string        avs_Symbol                                                                                    ; //<  96>
int           avi_Period                                                                                    ; //<  97>
                                                                                                              //<  98>
//</2.1. Global Data >----------------------------------------------------------------------------------------//<  99>
                                                                                                              //< 100>
//< 2.2. Special Functions >----------------------------------------------------------------------------------//< 101>
                                                                                                              //< 102>
//< A.System.Indicator: Function init >```````````````````````````````````````````````````````````````````````//< 103>
                                                                                                              //< 104>
int    init   ()                                                                                              //< 105>
{                                                                                                             //< 106>
avs_Symbol                            = Symbol ()                                                           ; //< 107>
avi_Period                            = Period ()                                                           ; //< 108>
                                                                                                              //< 109>
avi_SetupSynthSize                    = aci_Timeframe [ aei_ID ]                                            ; //< 110>
avi_SetupColorBars                    = aci_Color     [ aei_ID ]                                            ; //< 111>
avi_SetupColorMeans                   = aci_Color     [ aei_ID ]                                            ; //< 112>
avi_SetupColorSlopes                  = aci_Color     [ aei_ID ]                                            ; //< 113>
                                                                                                              //< 114>
if ( aei_ID < 1                                                                                               //< 115>
  || aei_ID > 9 )  avi_SetupSynthSize = avi_Period                                                          ; //< 116>
                                                                                                              //< 117>
arv_Chart   [ ari_TimeZero         ]  = EMPTY                                                               ; //< 118>
arv_Chart   [ ari_TimeRight        ]  = EMPTY                                                               ; //< 119>
arv_Chart   [ ari_TimeLeft         ]  = EMPTY                                                               ; //< 120>
arv_Chart   [ ari_BarRight         ]  = EMPTY                                                               ; //< 121>
arv_Chart   [ ari_BarLeft          ]  = EMPTY                                                               ; //< 122>
arv_Chart   [ ari_BarsShift        ]  = EMPTY                                                               ; //< 123>
arv_Chart   [ ari_BarsTotal        ]  = EMPTY                                                               ; //< 124>
arv_Chart   [ ari_Resolution_H     ]  = EMPTY                                                               ; //< 125>
arv_Chart   [ ari_PriceMax         ]  = EMPTY                                                               ; //< 126>
arv_Chart   [ ari_PriceMin         ]  = EMPTY                                                               ; //< 127>
arv_Chart   [ ari_PriceRange       ]  = EMPTY                                                               ; //< 128>
arv_Chart   [ ari_Resolution_V     ]  = EMPTY                                                               ; //< 129>
                                                                                                              //< 130>
avs_Prefix                            = A_System_Series   + A_System_Modification+"/"+(string)aei_ID+"_"    ; //< 131>
                                                                                                              //< 132>
avs_SetupBegin                        = avs_Prefix        + "Setup_0_Begin_======================="         ; //< 133>
avs_SetupSynthFrames                  = avs_Prefix        + "Setup_1_1_SynthFrames"                         ; //< 134>
avs_SetupSynthSize                    = avs_Prefix        + "Setup_1_2_SynthSize"                           ; //< 135>
avs_SetupColorBars                    = avs_Prefix        + "Setup_2_1_BarsColor"                           ; //< 136>
avs_SetupColorMeans                   = avs_Prefix        + "Setup_2_2_MeanLinesColor"                      ; //< 137>
avs_SetupColorSlopes                  = avs_Prefix        + "Setup_2_3_SlopesColor"                         ; //< 138>
avs_SetupEnd                          = avs_Prefix        + "Setup_9_End_========================="         ; //< 139>
                                                                                                              //< 140>
avs_PrefixSynthBars                   = avs_Prefix        + "SynthBar_"                                     ; //< 141>
avs_PrefixSynthMeanA                  = avs_Prefix        + "SynthMean_A"                                   ; //< 142>
avs_PrefixSynthMeanB                  = avs_Prefix        + "SynthMean_B"                                   ; //< 143>
avs_PrefixSynthSlopeA                 = avs_Prefix        + "SynthSlopeA_"                                  ; //< 144>
avs_PrefixSynthSlopeB                 = avs_Prefix        + "SynthSlopeB_"                                  ; //< 145>
                                                                                                              //< 146>
//< Existing Objects Deletion >                                                                               //< 147>
int   ali_PrefixDigits                = StringLen                     ( avs_Prefix                        ) ; //< 148>
                                                                                                              //< 149>
int   i , N ; N         = ObjectsTotal ()       - 1                                                         ; //< 150>
for ( i = N ; i >= 0    ; i --                                     )                                          //< 151>
    { if ( StringLen    ( ObjectName  ( i ) )  >= ali_PrefixDigits )                                          //< 152>
      if ( StringSubstr ( ObjectName  ( i ) , 0 , ali_PrefixDigits ) == avs_Prefix )                          //< 153>
           ObjectDelete ( ObjectName  ( i )                        )                                      ; } //< 154>
                                                                                                              //< 155>
GlobalVariablesDeleteAll                                              ( avs_Prefix                        ) ; //< 156>
//</Existing Objects Deletion >                                                                               //< 157>
                                                                                                              //< 158>
avi_FlagSynthFramesShow               = 0                                                                   ; //< 159>
avi_FlagSynthFramesCreate             = 0                                                                   ; //< 160>
                                                                                                              //< 161>
GlobalVariableSet                     ( avs_SetupBegin         , avi_SetupBegin                           ) ; //< 162>
GlobalVariableSet                     ( avs_SetupSynthFrames   , avi_SetupSynthFrames                     ) ; //< 163>
GlobalVariableSet                     ( avs_SetupSynthSize     , avi_SetupSynthSize                       ) ; //< 164>
GlobalVariableSet                     ( avs_SetupColorBars     , avi_SetupColorBars                       ) ; //< 165>
GlobalVariableSet                     ( avs_SetupColorMeans    , avi_SetupColorMeans                      ) ; //< 166>
GlobalVariableSet                     ( avs_SetupColorSlopes   , avi_SetupColorSlopes                     ) ; //< 167>
GlobalVariableSet                     ( avs_SetupEnd           , avi_SetupEnd                             ) ; //< 168>
                                                                                                              //< 169>
avs_SystemStamp                       = A_System_Name          + ": " +                                       //< 170>
                                        A_System_Series        +                                              //< 171>
                                        A_System_Modification  + "/"  + (string)aei_ID + " "  +               //< 172>
                                        A_System_Program                                                    ; //< 173>
                                                                                                              //< 174>
Alert                                 ( avs_SystemStamp        , ": Symbol="                              ,   //< 175>
                                        avs_Symbol             , ", Period="                              ,   //< 176>
                                        avi_Period             , ", Reload code="                         ,   //< 177>
                                        UninitializeReason ()                                             ) ; //< 178>
return(0);}                                                                                                   //< 179>
//</A_System_Indicator: Function init >```````````````````````````````````````````````````````````````````````//< 180>
                                                                                                              //< 181>
//< A_System_Indicator: Function deinit >`````````````````````````````````````````````````````````````````````//< 182>
                                                                                                              //< 183>
int    deinit ()                                                                                              //< 184>
{                                                                                                             //< 185>
afr_DeleteSynthFrames                 ()                                                                    ; //< 186>
                                                                                                              //< 187>
GlobalVariablesDeleteAll              ( avs_Prefix                                                        ) ; //< 188>
                                                                                                              //< 189>
Alert                                 ( avs_SystemStamp        , ": Stop code="   , UninitializeReason () ) ; //< 190>
return(0);}                                                                                                   //< 191>
//</A_System_Indicator: Function deinit >`````````````````````````````````````````````````````````````````````//< 192>
                                                                                                              //< 193>
//< A_System_Indicator: Function start >``````````````````````````````````````````````````````````````````````//< 194>
                                                                                                              //< 195>
int    start  ()                                                                                              //< 196>
{                                                                                                             //< 197>
static bool alb_RunFlag    ; if     ( ! alb_RunFlag ) {                                                       //< 198>
  if ( NormalizeDouble     ( MarketInfo ( avs_Symbol      , MODE_TICKVALUE ) , Digits ) > 0 )                 //< 199>
       alb_RunFlag         = True                                                                         ;   //< 200>
  else return(0)                                                                                          ; } //< 201>
                                                                                                              //< 202>
if ( ! GlobalVariableCheck ( avs_SetupBegin             ) )                                                   //< 203>
       GlobalVariableSet   ( avs_SetupBegin               , avi_SetupBegin                                ) ; //< 204>
if ( ! GlobalVariableCheck ( avs_SetupSynthFrames       ) )                                                   //< 205>
       GlobalVariableSet   ( avs_SetupSynthFrames         , avi_SetupSynthFrames                          ) ; //< 206>
if ( ! GlobalVariableCheck ( avs_SetupSynthSize         ) )                                                   //< 207>
       GlobalVariableSet   ( avs_SetupSynthSize           , avi_SetupSynthSize                            ) ; //< 208>
if ( ! GlobalVariableCheck ( avs_SetupColorBars         ) )                                                   //< 209>
       GlobalVariableSet   ( avs_SetupColorBars           , avi_SetupColorBars                            ) ; //< 210>
if ( ! GlobalVariableCheck ( avs_SetupColorMeans        ) )                                                   //< 211>
       GlobalVariableSet   ( avs_SetupColorMeans          , avi_SetupColorMeans                           ) ; //< 212>
if ( ! GlobalVariableCheck ( avs_SetupColorSlopes       ) )                                                   //< 213>
       GlobalVariableSet   ( avs_SetupColorSlopes         , avi_SetupColorSlopes                          ) ; //< 214>
if ( ! GlobalVariableCheck ( avs_SetupEnd               ) )                                                   //< 215>
       GlobalVariableSet   ( avs_SetupEnd                 , avi_SetupEnd                                  ) ; //< 216>
                                                                                                              //< 217>
if ( arv_Chart [ ari_TimeZero      ] != Time [ 0    ]                                                         //< 218>
  || arv_Chart [ ari_BarLeft       ] != WindowFirstVisibleBar                                            ()   //< 219>
  || arv_Chart [ ari_Resolution_H  ] != WindowBarsPerChart                                               ()   //< 220>
  || arv_Chart [ ari_PriceMax      ] != WindowPriceMax                                                   ()   //< 221>
  || arv_Chart [ ari_PriceMin      ] != WindowPriceMin                                                   ()   //< 222>
  || avi_SetupSynthSize              != GlobalVariableGet ( avs_SetupSynthSize                            )   //< 223>
  || avi_SetupColorBars              != GlobalVariableGet ( avs_SetupColorBars                            )   //< 224>
  || avi_SetupColorMeans             != GlobalVariableGet ( avs_SetupColorMeans                           )   //< 225>
  || avi_SetupColorSlopes            != GlobalVariableGet ( avs_SetupColorSlopes                          ) ) //< 226>
                                                                                                              //< 227>
   { avi_SetupSynthSize               = GlobalVariableGet ( avs_SetupSynthSize                            ) ; //< 228>
     avi_SetupColorBars               = GlobalVariableGet ( avs_SetupColorBars                            ) ; //< 229>
     avi_SetupColorMeans              = GlobalVariableGet ( avs_SetupColorMeans                           ) ; //< 230>
     avi_SetupColorSlopes             = GlobalVariableGet ( avs_SetupColorSlopes                          ) ; //< 231>
                                                                                                              //< 232>
     afr_DeleteSynthFrames                                                                               () ; //< 233>
     avi_FlagSynthFramesCreate        = 1                                                                   ; //< 234>
                                                                                                              //< 235>
     afr_MeasureChart                                                                                  () ; } //< 236>
                                                                                                              //< 237>
if ( GlobalVariableGet ( avs_SetupSynthFrames ) == 1 )                                                        //< 238>
   { if ( avi_FlagSynthFramesShow    == 0            )                                                        //< 239>
        { avi_FlagSynthFramesShow     = 1                                                                 ;   //< 240>
          avi_FlagSynthFramesCreate   = 1                                                                 ; } //< 241>
     afr_PlotSynthFrames                                                                               () ; } //< 242>
else if ( avi_FlagSynthFramesShow    == 1            )                                                        //< 243>
        { avi_FlagSynthFramesShow     = 0                                                                 ;   //< 244>
          afr_DeleteSynthFrames                                                                        () ; } //< 245>
return(0);}                                                                                                   //< 246>
//</A_System_Indicator: Function start >``````````````````````````````````````````````````````````````````````//< 247>
                                                                                                              //< 248>
//</2_2_ Special Functions >----------------------------------------------------------------------------------//< 249>
                                                                                                              //< 250>
//< 2_3_ Common  Functions >----------------------------------------------------------------------------------//< 251>
                                                                                                              //< 252>
//< A_System_Indicator: Function  List >``````````````````````````````````````````````````````````````````````//< 253>
// 01 int    afr_MeasureChart                                                                         //   20 //< 254>
// 02 int    afr_CreateLineT                                                                          //    5 //< 255>
// 03 int    afr_CreateFrame                                                                          //    3 //< 256>
// 04 int    afr_DeleteSynthFrames                                                                    //    8 //< 257>
// 05 int    afr_PlotSynthFrames                                                                      //   55 //< 258>
//< A_System_Indicator: Function  List >``````````````````````````````````````````````````````````````````````//< 259>
                                                                                                              //< 260>
//< A_System_Indicator: Function  1 >`````````````````````````````````````````````````````````````````````````//< 261>
void    afr_MeasureChart                   ()                                                          //   20 //< 262>
{                                                                                                             //< 263>
arv_Chart      [ ari_Resolution_H   ] = WindowBarsPerChart                                               () ; //< 264>
arv_Chart      [ ari_BarLeft        ] = WindowFirstVisibleBar                                            () ; //< 265>
                                                                                                              //< 266>
if ( arv_Chart [ ari_BarLeft        ] < arv_Chart [ ari_Resolution_H ] )                                      //< 267>
     arv_Chart [ ari_BarRight       ] = 0                                                                   ; //< 268>
else arv_Chart [ ari_BarRight       ] = arv_Chart [ ari_BarLeft      ] - arv_Chart [ ari_Resolution_H ]     ; //< 269>
                                                                                                              //< 270>
arv_Chart      [ ari_BarsTotal      ] = arv_Chart [ ari_BarLeft      ] - arv_Chart [ ari_BarRight     ] + 1 ; //< 271>
arv_Chart      [ ari_BarsShift      ] = arv_Chart [ ari_Resolution_H ] - arv_Chart [ ari_BarsTotal    ]     ; //< 272>
                                                                                                              //< 273>
arv_Chart      [ ari_TimeZero       ] = Time      [ 0                ]                                      ; //< 274>
int              ali_IndexRight       = arv_Chart [ ari_BarRight     ]                                      ; //< 275>
int              ali_IndexLeft        = arv_Chart [ ari_BarLeft      ]                                      ; //< 276>
arv_Chart      [ ari_TimeRight      ] = Time      [ ali_IndexRight   ]                                      ; //< 277>
arv_Chart      [ ari_TimeLeft       ] = Time      [ ali_IndexLeft    ]                                      ; //< 278>
                                                                                                              //< 279>
arv_Chart      [ ari_PriceMax       ] = WindowPriceMax                                                   () ; //< 280>
arv_Chart      [ ari_PriceMin       ] = WindowPriceMin                                                   () ; //< 281>
arv_Chart      [ ari_PriceRange     ] = arv_Chart [ ari_PriceMax     ] - arv_Chart [ ari_PriceMin     ]     ; //< 282>
arv_Chart      [ ari_Resolution_V   ] = arv_Chart [ ari_PriceRange   ] / Point                              ; //< 283>
}                                                                                                             //< 284>
//</A_System_Indicator: Function  1 >`````````````````````````````````````````````````````````````````````````//< 285>
                                                                                                              //< 286>
//< A_System_Indicator: Function  2 >`````````````````````````````````````````````````````````````````````````//< 287>
void    afr_CreateLineT                    (                                                           //    5 //< 288>
       string  aas_Name                   ,                                                                   //< 289>
       int     aai_Color                  ,                                                                   //< 290>
       int     aai_Width                  ,                                                                   //< 291>
       int     aai_Style                  ,                                                                   //< 292>
       int     aai_Ray                    ,                                                                   //< 293>
       int     aai_Time1                  ,                                                                   //< 294>
       double  aad_Price1                 ,                                                                   //< 295>
       int     aai_Time2                  ,                                                                   //< 296>
       double  aad_Price2                 )                                                                   //< 297>
{                                                                                                             //< 298>
ObjectCreate ( aas_Name  , OBJ_TREND  , 0 , aai_Time1 , aad_Price1 , aai_Time2  , aad_Price2              ) ; //< 299>
ObjectSet    ( aas_Name  , OBJPROP_COLOR  , aai_Color                                                     ) ; //< 300>
ObjectSet    ( aas_Name  , OBJPROP_WIDTH  , aai_Width                                                     ) ; //< 301>
ObjectSet    ( aas_Name  , OBJPROP_STYLE  , aai_Style                                                     ) ; //< 302>
ObjectSet    ( aas_Name  , OBJPROP_RAY    , aai_Ray                                                       ) ; //< 303>
}                                                                                                             //< 304>
//</A_System_Indicator: Function  2 >`````````````````````````````````````````````````````````````````````````//< 305>
                                                                                                              //< 306>
//< A_System_Indicator: Function  3 >`````````````````````````````````````````````````````````````````````````//< 307>
void    afr_CreateFrame                    (                                                           //    3 //< 308>
       string  aas_Name                   ,                                                                   //< 309>
       int     aai_Color                  ,                                                                   //< 310>
       int     aai_BackGround             ,                                                                   //< 311>
       int     aai_Time1                  ,                                                                   //< 312>
       double  aad_Price1                 ,                                                                   //< 313>
       int     aai_Time2                  ,                                                                   //< 314>
       double  aad_Price2                 )                                                                   //< 315>
{                                                                                                             //< 316>
ObjectCreate ( aas_Name  , OBJ_RECTANGLE  , 0 , aai_Time1 , aad_Price1 , aai_Time2 , aad_Price2           ) ; //< 317>
ObjectSet    ( aas_Name  , OBJPROP_COLOR  , aai_Color                                                     ) ; //< 318>
ObjectSet    ( aas_Name  , OBJPROP_BACK   , aai_BackGround                                                ) ; //< 319>
}                                                                                                             //< 320>
//</A_System_Indicator: Function  3 >`````````````````````````````````````````````````````````````````````````//< 321>
                                                                                                              //< 322>
//< A_System_Indicator: Function  4 >`````````````````````````````````````````````````````````````````````````//< 323>
void    afr_DeleteSynthFrames              ()                                                          //    8 //< 324>
{                                                                                                             //< 325>
int    i , N ; N = avi_Synths                                                                               ; //< 326>
for (  i = 0 ; i < N     ; i ++                      )                                                        //< 327>
    {  ObjectDelete      ( avs_PrefixSynthBars   + (string)i )                                                      ; //< 328>
       ObjectDelete      ( avs_PrefixSynthMeanA  + (string)i )                                                      ; //< 329>
       ObjectDelete      ( avs_PrefixSynthMeanB  + (string)i )                                                      ; //< 330>
       ObjectDelete      ( avs_PrefixSynthSlopeA + (string)i )                                                      ; //< 331>
       ObjectDelete      ( avs_PrefixSynthSlopeB + (string)i )                                                    ; } //< 332>
                                                                                                              //< 333>
avi_Synths = 0                                                                                              ; //< 334>
}                                                                                                             //< 335>
//</A_System_Indicator: Function  4 >`````````````````````````````````````````````````````````````````````````//< 336>
                                                                                                              //< 337>
//< A_System_Indicator: Function  5 >`````````````````````````````````````````````````````````````````````````//< 338>
void    afr_PlotSynthFrames                ()                                                          //   55 //< 339>
{                                                                                                             //< 340>
int    ali_Synth          = avi_SetupSynthSize                                                              ; //< 341>
                                                                                                              //< 342>
if   ( iBars ( avs_Symbol , ali_Synth )  < 2      )                                                  return ; //< 343>
                                                                                                              //< 344>
if   ( avi_FlagSynthFramesCreate    == 1          )                                                           //< 345>
     { avi_FlagSynthFramesCreate     = 0                                                                    ; //< 346>
                                                                                                              //< 347>
       if ( avi_Period              <= ali_Synth  )                                                           //< 348>
          {                                                                                                   //< 349>
            double  ald_Spread       = Ask        - Bid                                                     ; //< 350>
                                                                                                              //< 351>
            int  ali_TimeChartBegin  = iTime      ( avs_Symbol  , avi_Period , arv_Chart [ ari_BarRight ] ) ; //< 352>
            int  ali_TimeChartEnd    = iTime      ( avs_Symbol  , avi_Period , arv_Chart [ ari_BarLeft  ] ) ; //< 353>
                                                                                                              //< 354>
            if ( ali_TimeChartBegin  < iTime      ( avs_Symbol  , ali_Synth  , 0 ) )                          //< 355>
                 avi_IndexSynthBegin = iBarShift  ( avs_Symbol  , ali_Synth  , ali_TimeChartBegin         ) ; //< 356>
            else avi_IndexSynthBegin = 0                                                                    ; //< 357>
                                                                                                              //< 358>
            if ( ali_TimeChartEnd    < iTime      ( avs_Symbol  , ali_Synth  , 0 ) )                          //< 359>
                 avi_IndexSynthEnd   = iBarShift  ( avs_Symbol  , ali_Synth  , ali_TimeChartEnd           ) ; //< 360>
            else avi_IndexSynthEnd   = 0                                                                    ; //< 361>
                                                                                                              //< 362>
            if ( avi_IndexSynthEnd  == avi_IndexSynthBegin      ) avi_IndexSynthEnd      ++                 ; //< 363>
                                                                                                              //< 364>
            avi_Synths              =  avi_IndexSynthEnd        - avi_IndexSynthBegin    + 1                ; //< 365>
                                                                                                              //< 366>
            int ali_Suffix   = 0                                                                            ; //< 367>
            int i , N   ; N  = avi_IndexSynthEnd                                                            ; //< 368>
            for (         i  = avi_IndexSynthBegin   ; i <= N      ; i ++               )                     //< 369>
                { if    ( i == 0 )                                                                            //< 370>
                    int   ali_Time1       = iTime    ( avs_Symbol  , ali_Synth  , i     ) + ali_Synth  * 60 ; //< 371>
                  else    ali_Time1       = iTime    ( avs_Symbol  , ali_Synth  , i - 1 )                   ; //< 372>
                  int     ali_Time2       = iTime    ( avs_Symbol  , ali_Synth  , i     )                   ; //< 373>
                  double  ald_BidHigh     = iHigh    ( avs_Symbol  , ali_Synth  , i     )                   ; //< 374>
                  double  ald_BidLow      = iLow     ( avs_Symbol  , ali_Synth  , i     )                   ; //< 375>
                  double  ald_AskHigh     =            ald_BidHigh + ald_Spread                             ; //< 376>
                  double  ald_AskLow      =            ald_BidLow  + ald_Spread                             ; //< 377>
                  double  ald_AverageA    =          ( ald_AskHigh + ald_AskLow         ) / 2               ; //< 378>
                  double  ald_AverageB    =          ( ald_BidHigh + ald_BidLow         ) / 2               ; //< 379>
                  double  ald_OpenBid     = iOpen    ( avs_Symbol  , ali_Synth  , i     )                   ; //< 380>
                  double  ald_CloseBid    = iClose   ( avs_Symbol  , ali_Synth  , i     )                   ; //< 381>
                  double  ald_OpenAsk     = ald_OpenBid            + ald_Spread                             ; //< 382>
                  double  ald_CloseAsk    = ald_CloseBid           + ald_Spread                             ; //< 383>
                                                                                                              //< 384>
                  afr_CreateFrame ( avs_PrefixSynthBars   + (string)ali_Suffix ,                                      //< 385>
                                    avi_SetupColorBars                             , 0  ,                     //< 386>
                                    ali_Time1 , ald_AskHigh            , ali_Time2 , ald_BidLow           ) ; //< 387>
                  afr_CreateLineT ( avs_PrefixSynthMeanA  + (string)ali_Suffix ,                                      //< 388>
                                    avi_SetupColorMeans                            , 1  , STYLE_DOT  , 0  ,   //< 389>
                                    ali_Time1 , ald_AverageA           , ali_Time2 , ald_AverageA         ) ; //< 390>
                  afr_CreateLineT ( avs_PrefixSynthMeanB  + (string)ali_Suffix ,                                      //< 391>
                                    avi_SetupColorMeans                            , 1  , STYLE_DOT  , 0  ,   //< 392>
                                    ali_Time1 , ald_AverageB           , ali_Time2 , ald_AverageB         ) ; //< 393>
                  afr_CreateLineT ( avs_PrefixSynthSlopeA + (string)ali_Suffix ,                                      //< 394>
                                    avi_SetupColorSlopes               ,             1  , STYLE_DASH , 0  ,   //< 395>
                                    ali_Time1 , ald_CloseAsk           , ali_Time2 , ald_OpenAsk          ) ; //< 396>
                  afr_CreateLineT ( avs_PrefixSynthSlopeB + (string)ali_Suffix ,                                      //< 397>
                                    avi_SetupColorSlopes               ,             1  , STYLE_DASH , 0  ,   //< 398>
                                    ali_Time1 , ald_CloseBid           , ali_Time2 , ald_OpenBid          ) ; //< 399>
                  ali_Suffix ++                                                                         ; } } //< 400>
     } // if                                                                                                  //< 401>
}                                                                                                             //< 402>
//</A.System.Indicator: Function  5 >`````````````````````````````````````````````````````````````````````````//< 403>
                                                                                                              //< 404>
//</2.3. Common  Functions >----------------------------------------------------------------------------------//< 405>
                                                                                                              //< 406>
//</2. Program  >=============================================================================================//< 407>